'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AutoComplete = require('material-ui/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AutoCompleteInput = _react2.default.createClass({
    displayName: 'AutoCompleteInput',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        defaultValue: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number])
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },
    _onChange: function _onChange(value) {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, value);
        }
        if (this.props.onChange) {
            this.props.onChange(value);
        }
    },

    render: function render() {

        var options = this.props.dataSource;

        if (this.props.useAllowedValues) {
            if (this.props.allowedValues) {
                options = [];
                this.props.allowedValues.map(function (value) {
                    options.push({ label: value, value: value });
                });
            } else {
                console.error("Auto complete input " + this.props.name + " has useAllowedValues but does not have any allowedValues");
            }
        }

        return _react2.default.createElement(
            'div',
            { style: _reactSsFormHandler.FormLayoutStyles[this.props.layoutStyle] },
            _react2.default.createElement(_AutoComplete2.default, _extends({ fullWidth: true, autoComplete: 'off', onUpdateInput: this._onChange }, this.props, { placeholder: null, hintText: this.props.placeholder, dataSource: options, floatingLabelText: this.props.label, errorText: this.props.errorText }))
        );
    }
});

exports.default = AutoCompleteInput;