'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Checkbox = _react2.default.createClass({
    displayName: 'Checkbox',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        defaultValue: _react2.default.PropTypes.bool
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },

    _onCheck: function _onCheck(event, checked) {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, checked);
        }

        if (this.props.onChange) {
            this.props.onChange(checked);
        }
    },
    render: function render() {
        return _react2.default.createElement(
            'div',
            { style: _reactSsFormHandler.FormLayoutStyles[this.props.layoutStyle] },
            _react2.default.createElement(_Checkbox2.default, _extends({ ref: 'checkbox' }, this.props, { defaultChecked: this.props.defaultValue, value: this.props.name, onCheck: this._onCheck }))
        );
    }
});

exports.default = Checkbox;