'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DatePicker = require('material-ui/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DatePicker = _react2.default.createClass({
    displayName: 'DatePicker',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        defaultValue: _react2.default.PropTypes.object
    },
    getInitialState: function getInitialState() {
        return {
            value: this.props.defaultValue
        };
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        this.setState({
            value: nextProps.value
        });
    },
    _onChange: function _onChange(event, date) {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, date);
        }

        if (this.props.onChange) {
            this.props.onChange(value);
        }

        this.setState({
            value: date
        });
    },

    render: function render() {
        return _react2.default.createElement(
            'div',
            { style: _reactSsFormHandler.FormLayoutStyles[this.props.layoutStyle] },
            _react2.default.createElement(_DatePicker2.default, _extends({ ref: 'datepicker', fullWidth: true, onChange: this._onChange }, this.props, { floatingLabelText: this.props.label, placeholder: null, errorText: this.props.errorText, value: this.state.value })),
            _react2.default.createElement('input', { type: 'hidden', name: this.props.name, value: this.state.value })
        );
    }
});

exports.default = DatePicker;