'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RadioButton = require('material-ui/RadioButton');

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioButtonGroup = _react2.default.createClass({
    displayName: 'RadioButtonGroup',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        defaultValue: _react2.default.PropTypes.string
    },
    getInitialState: function getInitialState() {
        return {
            value: this.props.defaultValue
        };
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },

    _onChange: function _onChange(event, selected) {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, selected);
        }

        if (this.props.onChange) {
            this.props.onChange(value);
        }

        this.setState({
            value: selected
        });
    },
    render: function render() {
        return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
                _RadioButton.RadioButtonGroup,
                { name: this.props.name, defaultSelected: this.props.defaultValue, onChange: this._onChange },
                this.props.children
            ),
            _react2.default.createElement('input', { type: 'hidden', name: this.props.name, value: this.state.value })
        );
    }
});

exports.default = RadioButtonGroup;