'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = _react2.default.createClass({
    displayName: 'Select',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        options: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object),
        defaultValue: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number])
    },
    getInitialState: function getInitialState() {
        return {
            value: this.props.defaultValue
        };
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },
    _onChange: function _onChange(event, index, value) {
        this.setState({
            value: value
        });

        if (this.props.onChange) {
            this.props.onChange(value);
        }

        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, value);
        }
    },

    render: function render() {

        var options = [];

        if (this.props.useAllowedValues) {
            if (this.props.allowedValues) {
                this.props.allowedValues.map(function (value) {
                    options.push(_react2.default.createElement(_MenuItem2.default, { key: value, value: value, primaryText: value }));
                });
            } else {
                console.error("Select input " + this.props.name + " has useAllowedValues but does not have any allowedValues");
            }
        } else {
            this.props.options.map(function (option) {
                options.push(_react2.default.createElement(_MenuItem2.default, { key: option.value, value: option.value, primaryText: option.label }));
            });
        }

        return _react2.default.createElement(
            'div',
            { style: _reactSsFormHandler.FormLayoutStyles[this.props.layoutStyle] },
            _react2.default.createElement(
                _SelectField2.default,
                _extends({}, this.props, { fullWidth: true, onChange: this._onChange, floatingLabelText: this.props.label, hintText: this.props.placeholder, placeholder: null, errorText: this.props.errorText, value: this.state.value }),
                options
            ),
            _react2.default.createElement('input', { type: 'hidden', name: this.props.name, value: this.state.value })
        );
    }
});

exports.default = Select;