'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _reactSsFormHandler = require('react-ss-form-handler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextArea = _react2.default.createClass({
    displayName: 'TextArea',

    propTypes: {
        name: _react2.default.PropTypes.string.isRequired,
        layoutStyle: _react2.default.PropTypes.oneOf(_reactSsFormHandler.AvailableFormLayoutStyles),
        defaultValue: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number])
    },
    componentWillMount: function componentWillMount() {
        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.initializeInput(this.props.formId, this.props.name, this.props.defaultValue);
        }
    },
    _onChange: function _onChange(event) {

        var value = event.nativeEvent.target.value;

        if (this.props.type === "number") {
            value = parseFloat(value);
        }

        if (this.props.onChange) {
            this.props.onChange(value);
        }

        if (this.props.formId) {
            _reactSsFormHandler.FormHandler.inputChanged(this.props.formId, this.props.name, value);
        }
    },

    render: function render() {
        return _react2.default.createElement(
            'div',
            { style: _reactSsFormHandler.FormLayoutStyles[this.props.layoutStyle] },
            _react2.default.createElement(_TextField2.default, _extends({ fullWidth: true, onChange: this._onChange }, this.props, { multiLine: true, placeholder: null, hintText: this.props.placeholder, floatingLabelText: this.props.label, errorText: this.props.errorText }))
        );
    }
});

exports.default = TextArea;